using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;


using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GroupingMaster
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			GridEngineFactory.Factory = new GroupingEngineFactory(); 
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(19, 14);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(356, 426);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.51";
			this.gridGroupingControl1.RecordExpanded += new Syncfusion.Grouping.RecordEventHandler(this.gridGroupingControl1_RecordExpanded);
			this.gridGroupingControl1.RecordCollapsing += new Syncfusion.Grouping.RecordEventHandler(this.gridGroupingControl1_RecordCollapsing);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(392, 462);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private int parentRows = 10;
		private int ChildRows = 30;
		private int GrandChildRows = 80;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));

			for(int i = 0; i < parentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private Random r = new Random();

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < ChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = (i % parentRows).ToString();
				if(dr[0].ToString() == "2")
				{
					Console.WriteLine(dr[2].ToString());  
				}
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < GrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				if(i%2 == 0)
					dr[2] = (i % ChildRows).ToString();
				else
					dr[2] =1;
				dt.Rows.Add(dr);
			}
			
			return dt;
		}

		DataSet ds = new DataSet();
		private void Init()
		{

			DataTable dtParent = GetParentTable();
			DataTable dtChild = GetChildTable();
			DataTable dtgrandChild = GetGrandChildTable(); 

			ds.Tables.Add(dtParent);
			ds.Tables.Add(dtChild);
			ds.Tables.Add(dtgrandChild);
			
			ds.Relations.Add("Parent_Child",ds.Tables[0].Columns["ParentID"],ds.Tables[1].Columns["ParentID"]);      
            ds.Relations.Add("Child_GrandChild",ds.Tables[1].Columns["ChildID"],ds.Tables[2].Columns["ChildID"]);      
			
			this.gridGroupingControl1.DataSource = ds.Tables[0]; 
			
			this.gridGroupingControl1.TopLevelGroupOptions.ShowCaption = false; 
			this.gridGroupingControl1.NestedTableGroupOptions.ShowCaption = false; 
			
		
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			Init();
		}

		ArrayList ExpandedZeroRecord = new ArrayList();

		private void gridGroupingControl1_RecordExpanded(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(e.Record.ChildTableGroupLevel == 1)
			{
				int ExpandedRecordCount = e.Record.GetNestedTablesVisibleCount();
				int rowIndex = this.gridGroupingControl1.Table.NestedDisplayElements.IndexOf(e.Record);    
				 
				if( ExpandedRecordCount == 2)
				{
					ExpandedZeroRecord.Add(e.Record);  
					this.gridGroupingControl1.TableModel.RowHeights[ rowIndex + 1 ] = 0;
				} 
			}
		}

		private void gridGroupingControl1_RecordCollapsing(object sender, Syncfusion.Grouping.RecordEventArgs e)
		{
			if(ExpandedZeroRecord.Contains(e.Record))
			{
				int ExpandedRecordCount = e.Record.GetNestedTablesVisibleCount();
				int rowIndex = this.gridGroupingControl1.Table.NestedDisplayElements.IndexOf(e.Record);    
				this.gridGroupingControl1.TableModel.RowHeights.ResetSize( rowIndex +1 ); 
				ExpandedZeroRecord.Remove(e.Record);
			}
		}

		

		

		
	}
}
